#include "yourcode.h"

/// streq compares to strings
bool streq(char *s1, char *s2)
{
  if (strcmp(s1,s2) == 0)
    {
      return true;
    }
  else
    {
      return false;
    }
}

/// strdup equivalent since it does not always work on some machines
char *str(char *in)
{
  int len = strlen(in);
  char *out = calloc(len + 1, sizeof(char));
  for (int i = 0; i < len; ++i)
    {
      out[i] = in[i];
    }
  return out;
}

void print(list_t *list)
{
    char *str = list_print(list, NULL);
    printf("%s\n", str);
    free(str);
}

void list_test()
{
  list_t *a = list_create((void_eq) streq);

  list_t *b = list_create((void_eq) streq);
  list_insert(b,"a");
  link_t *b1 = b->first;

  list_t *c = list_create((void_eq) streq);
  list_insert(c,"a");
  list_insert(c,"b");
  list_insert(c,"b");
  list_insert(c,"c");
  list_insert(c,"b");
  list_insert(c,"a");
  link_t *c1 = c->first;
  link_t *c2 = c1->next;
  link_t *c3 = c2->next->next;

  puts("Expecting empty list to be unchanged:");
  list_remove_dups(a);
  printf("  %s\n", (list_size(a) == 0 ? "PASSED" : "FAILED"));

  puts("\nExpecting one-element list to be unchanged:");
  list_remove_dups(b);
  printf("  %s\n", (list_size(b) == 1 && streq(b->first->element,"a")
      && b->last == b->first && b->last->next == NULL ? "PASSED" : "FAILED"));

  puts("\nExpecting the list [a,b,b,c,b,a] to be changed into [a,b,c], while");
  puts(" keeping the links of the first occurrences and updating the last pointer.");
  printf("List c before list_remove_dups: "); print(c);
  list_remove_dups(c);
  printf("  %s\n", (c->first == c1 && c1->next == c2 && c2->next == c3
      && c->last == c3 && c3->next == NULL ? "PASSED" : "FAILED"));
  printf(" List c after list_remove_dups: "); print(c);

  list_destroy(a);
  list_destroy(b);
  list_destroy(c);
}  

int main(void)
{
  puts("\n= = = = = = = = = = = = = = = = = = = = = = = = = = = TEST START = =");
  list_test();
  puts("= = = = = = = = = = = = = = = = = = = = = = = = = = = TEST  STOP = =\n");
  return 0;
}
