#ifndef __yourcode__
#define __yourcode__
#include <stdbool.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

typedef bool(*void_eq)(void *e1, void *e2);
typedef char *(*elem_to_string)(void *e);

typedef struct link link_t;
typedef struct list list_t;

struct list
{
  link_t *first;
  link_t *last;
  void_eq eq;
};

struct link
{
  link_t *next;
  void *element;
};

/// Create a new sorted (empty) list -- compare is a function that defines the sort order for the elements.
list_t *list_create(void_eq compare);
/// Insert element into list according to the sort order
void list_insert(list_t *list, void *element);
/// Merge the two lists into dest, leaving source empty (note: implemented so that links move, not just elements!)
void list_remove_dups(list_t *list);
/// Return the number of elements in the list
int list_size(list_t *list);
/// Remove the list and its elements from memory
void list_destroy(list_t *list);
/// Return the string representation for the list, e.g. [a, b, c]
char *list_print(list_t *list, elem_to_string to_string);

#endif

