#include <string.h>
#include "yourcode.h"

/// streq compares to strings
bool streq(char *s1, char *s2)
{
  if (strcmp(s1,s2) == 0)
    {
      return true;
    }
  else
    {
      return false;
    }
}

/// strdup equivalent since it does not always work on some machines
char *str(char *in)
{
  int len = strlen(in);
  char *out = calloc(len + 1, sizeof(char));
  for (int i = 0; i < len; ++i)
    {
      out[i] = in[i];
    }
  return out;
}


void print(list_t *list)
{
    char *str = list_print(list, NULL);
    printf("'%s'\n", str);
    free(str);
}


void list_test()
{
  list_t *a = list_create((void_eq) streq);
  list_t *b = list_create((void_eq) streq);
  list_t *c = list_create((void_eq) streq);

  list_insert(b,"a");

  list_insert(c,"a");
  list_insert(c,"b");
  list_insert(c,"b");
  list_insert(c,"c");
  list_insert(c,"b");
  list_insert(c,"a");

  link_t *ca = c->first;
  link_t *cb = ca->next;
  link_t *cc = cb->next->next;

  puts("Expecting empty list to be unchanged");
  list_remove_dups(a);
  printf("%s\n", (list_size(a) == 0 ? "PASSED" : "FAILED"));

  puts("Expecting one-element list to be unchanged");
  list_remove_dups(b);
  printf("%s\n", (list_size(b) == 1 && streq(b->first->element,"a") ?
		 "PASSED" : "FAILED"));

  puts("Expecting the list '[a,b,b,c,b,a]' to be changed into '[a,b,c]',");
  puts("while keeping the links of the first occurrences.");
  list_remove_dups(c);
  printf("%s\n", (c->first == ca && ca->next == cb && cb->next == cc &&
		  c->last == cc && cc->next == NULL ?
		 "PASSED" : "FAILED"));

  list_destroy(a);
  list_destroy(b);
  list_destroy(c);

}  

int main(void)
{
  puts("=========================== TEST START =================================");
  list_test();
  puts("=========================== TEST STOP ==================================\n");
  
  return 0;
}
